package pep;

import java.io.*;
import static pep.Main.nSubjects; import static pep.Main.multCue;
import static pep.Main.multTarg;  import static pep.Main.multDist;

/**This class concatenates individual data files into Dataset.txt. It also
 * encodes previous RTs, accuracy, and congruency. This class can be run
 * independently of the full model.*/
public class Concat{
 //----------VARIABLES--------------------------------------------------
 /**file name*/              static String fileName;
 /**number of variables*/    static int nVariables = Main.numPerVar.length;
 //---------------------------------------------------------------------
 /**response time*/          static int rt;
 /**previous response time*/ static int n1rt;
 /**accuracy*/               static int accuracy;
 /**previous accuracy*/      static int n1acc;

 /**Get data from each participant.
  * @param args Not used*/
 public static void main(String[] args){
  for(int i=1; i<=nSubjects; i++){
   clear();
   getData(i);
  }
 }

 /**Gets the data for the participant and writes it to file.
  * @param i Participant number.*/
 public static void getData(int i){
  BufferedReader in = null;
  String[] trialString = null;
  FileOutputStream out = null;
  PrintStream p = null;
  try{
   fileName = "out"+i+".txt";
   in = new BufferedReader(new FileReader(fileName));
   if(i>1) out = new FileOutputStream("Dataset.txt", true);
   else out = new FileOutputStream("Dataset.txt");
   p = new PrintStream(out);
  }
  catch(FileNotFoundException e){
   System.out.println("Error setting input and output streams.");
  }
  try{
   trialString = in.readLine().split("\\t");
  }
  catch(IOException e){
   System.out.println("No data in file.");
  }
  String cong = ""; String n1cong = "";
  while(in!=null){
   try{
    for(int c=0; c<trialString.length-1; c++) p.print(trialString[c]+"\t");
    int congIndex = 2+multCue+multTarg+multDist;
    cong = trialString[congIndex];
    int rtIndex = congIndex+nVariables+1;
    rt = Integer.parseInt(trialString[rtIndex]);    
    accuracy = Integer.parseInt(trialString[rtIndex+1]);
    if(n1rt==99999) p.print(" \t \t"+n1cong);
    else p.print(n1rt+"\t"+n1acc+"\t"+n1cong);
    p.println();
    n1rt = rt; n1acc = accuracy; n1cong = cong;
    String nextTrial = in.readLine();
    if(nextTrial.equals("END_OF_FILE")) in = null;
    else trialString = nextTrial.split("\\t");
   }
   catch(NumberFormatException | IOException e3){
    in = null;
    System.out.println("No END_OF_FILE in data file.");
   }
  }
  try{
   p.close(); out.close();
  }
  catch(IOException e2){
   System.out.println("Error closing input and output streams");
  }
 }

 /**Sets starting values for all variables.*/
 private static void clear(){
  n1rt = 99999;
  n1acc = 999;
 }
}