package pep;

/**This Node subclass defines the operations of Response nodes.*/
public class Response extends SubNode{
 /**total amount memory retrieved*/
 public static ThreadLocal<Double> totRetrieved = new ThreadLocal<>();

 /**Creates a new Response node.
  * @param subject Subject number used for static variable array.*/
 public Response(int subject){
  super(subject);
  strength = 3.5;
 }

 /**Computes interference and updates response activation.*/
 public void activate(){
  retrieve();
  input += addNoise(.0026);
  update();
 }

 /**Adds retrieved activation to input with SubNode method.*/
 private void retrieve(){
  double total = totRetrieved.get();
  double multiplier = Executive.resSearch.get();
  retrieve(total,multiplier);
 }

 /**Sends retrieval from Decision nodes.
  * @param in Input activation.*/
 public void send(double in){
  retrieved += in;
  totRetrieved.set(in+totRetrieved.get());
 }

 /**Clears totRetrieved for the next cycle.*/
 public static void clear(){
  totRetrieved.set(0.0);
 }
}